"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.useConnector = useConnector;
var _vueDemi = require("vue-demi");
var _fastDeepEqual = _interopRequireDefault(require("fast-deep-equal"));
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function useConnector(callback, defaultOptions) {
    var connector = function connector(element, options) {
        (0, _vueDemi).set(_state, "el", element);
        // Because of the special nature of vue, when it calls setRef, it will pass in two parameters. Therefore, when we pass connect as a setRef function, we may receive a non-ideal options. For this reason, we assume that when there are options in the spec, The options passed in by Connect are no longer adopted to ensure that the options of spec always take precedence over the options of connect
        var _options = (0, _vueDemi).unref(defaultOptions) || options;
        if (!(0, _fastDeepEqual).default(_state.options, _options)) {
            (0, _vueDemi).set(_state, "options", _options);
        }
        return (0, _vueDemi).unref(element);
    };
    var _state = (0, _vueDemi).reactive({
        el: null,
        options: (0, _vueDemi).unref(defaultOptions)
    });
    (0, _vueDemi).watchEffect(function() {
        callback(_state);
    }, {
        flush: "post"
    });
    return connector;
}
