"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.useDrop = useDrop;
var _useRegisteredDropTargetJs = require("./useRegisteredDropTarget.js");
var _useOptionalFactoryJs = require("../useOptionalFactory.js");
var _useDropTargetMonitorJs = require("./useDropTargetMonitor.js");
var _useDropTargetConnectorJs = require("./useDropTargetConnector.js");
var _useCollectedProps = require("../useCollectedProps");
var _connectors = require("./connectors");
var _vueDemi = require("vue-demi");
function useDrop(specArg) {
    var spec = (0, _useOptionalFactoryJs).useOptionalFactory(specArg);
    var monitor = (0, _useDropTargetMonitorJs).useDropTargetMonitor();
    var connector = (0, _useDropTargetConnectorJs).useDropTargetConnector((0, _vueDemi).computed(function() {
        return (0, _vueDemi).unref(spec).options;
    }));
    (0, _useRegisteredDropTargetJs).useRegisteredDropTarget(spec, monitor, connector);
    return [
        (0, _useCollectedProps).useCollectedProps((0, _vueDemi).computed(function() {
            return (0, _vueDemi).unref(spec).collect || function() {
                return {};
            };
        }), monitor, connector),
        (0, _connectors).useConnectDropTarget(connector, spec), 
    ];
}
