"use strict";
var _targetConnector = require("../TargetConnector");
var _vitest = require("vitest");
(0, _vitest).describe("TargetConnector", function() {
    (0, _vitest).it("unsubscribes drop target when clearing handler id", function() {
        var backend = {
            setup: _vitest.vi.fn(),
            teardown: _vitest.vi.fn(),
            connectDragSource: _vitest.vi.fn(),
            connectDragPreview: _vitest.vi.fn(),
            connectDropTarget: _vitest.vi.fn()
        };
        var connector = new _targetConnector.TargetConnector(backend);
        var unsubscribeDropTarget = _vitest.vi.fn();
        backend.connectDropTarget.mockReturnValueOnce(unsubscribeDropTarget);
        connector.receiveHandlerId("test");
        connector.hooks.dropTarget()({});
        (0, _vitest).expect(backend.connectDropTarget).toHaveBeenCalled();
        (0, _vitest).expect(unsubscribeDropTarget).not.toHaveBeenCalled();
        backend.connectDropTarget.mockClear();
        connector.receiveHandlerId(null);
        (0, _vitest).expect(backend.connectDropTarget).not.toHaveBeenCalled();
        (0, _vitest).expect(unsubscribeDropTarget).toHaveBeenCalled();
    });
});
