function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _asyncToGenerator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _iterableToArrayLimit(arr, i) {
    var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _s, _e;
    try {
        for(_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}
function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
import regeneratorRuntime from "regenerator-runtime";
import { useDrop } from "../useDrop";
import { render, cleanup } from "@testing-library/vue";
import { DndProvider } from "../..";
import { TestBackend } from "react-dnd-test-backend";
import { defineComponent, h } from "vue-demi";
import { describe, afterEach, it, vi, expect } from "vitest";
describe("The useDrop hook", function() {
    afterEach(cleanup);
    it("throws if rendered outside of a React-DnD tree", function() {
        var Component = defineComponent(function() {
            var ref = _slicedToArray(useDrop(function() {
                return {
                    accept: "box"
                };
            }), 2), drag = ref[1];
            // @ts-ignore
            return function() {
                return h("div", {
                    ref: drag
                });
            };
        });
        var err = console.error;
        try {
            var errorMock = vi.fn();
            console.error = errorMock;
            expect(function() {
                return render(Component);
            }).toThrow(/Expected drag drop context/);
        } finally{
            console.error = err;
        }
    });
    it("throws if accept is null", function() {
        var Component = defineComponent(function() {
            var ref = _slicedToArray(useDrop(function() {
                return {
                    accept: null
                };
            }), 2), drag = ref[1];
            // @ts-ignore
            return function() {
                return h("div", {
                    ref: drag
                });
            };
        });
        var TestComponent = defineComponent(function() {
            return function() {
                return h(DndProvider, {
                    backend: TestBackend
                }, {
                    default: function() {
                        return h(Component);
                    }
                });
            };
        });
        var err = console.error;
        try {
            var errorMock = vi.fn();
            console.error = errorMock;
            expect(function() {
                return render(TestComponent);
            }).toThrow(/accept must be defined/);
        } finally{
            console.error = err;
        }
    });
    it("can be used inside of a React-DnD context", _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
        var Component, TestComponent, result, root;
        return regeneratorRuntime.wrap(function _callee$(_ctx) {
            while(1)switch(_ctx.prev = _ctx.next){
                case 0:
                    Component = defineComponent(function() {
                        var ref = _slicedToArray(useDrop(function() {
                            return {
                                accept: "box"
                            };
                        }), 2), drag = ref[1];
                        // @ts-ignore
                        return function() {
                            return h("div", {
                                ref: drag,
                                role: "root"
                            });
                        };
                    });
                    TestComponent = defineComponent(function() {
                        return function() {
                            return h(DndProvider, {
                                backend: TestBackend
                            }, {
                                default: function() {
                                    return h(Component);
                                }
                            });
                        };
                    });
                    result = render(TestComponent);
                    _ctx.next = 5;
                    return result.findByRole("root");
                case 5:
                    root = _ctx.sent;
                    expect(root).toBeDefined();
                case 7:
                case "end":
                    return _ctx.stop();
            }
        }, _callee);
    })));
});
